package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.MerchantCategoryService;
import com.gxwebsoft.shop.entity.MerchantCategory;
import com.gxwebsoft.shop.param.MerchantCategoryParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商家分类控制器
 *
 * @author 科技小王子
 * @since 2024-09-30 13:05:32
 */
@Api(tags = "商家分类管理")
@RestController
@RequestMapping("/api/shop/merchant-category")
public class MerchantCategoryController extends BaseController {
    @Resource
    private MerchantCategoryService merchantCategoryService;

    @ApiOperation("分页查询商家分类")
    @GetMapping("/page")
    public ApiResult<PageResult<MerchantCategory>> page(MerchantCategoryParam param) {
        // 使用关联查询
        return success(merchantCategoryService.pageRel(param));
    }

    @ApiOperation("查询全部商家分类")
    @GetMapping()
    public ApiResult<List<MerchantCategory>> list(MerchantCategoryParam param) {
        // 使用关联查询
        return success(merchantCategoryService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:merchantCategory:list')")
    @ApiOperation("根据id查询商家分类")
    @GetMapping("/{id}")
    public ApiResult<MerchantCategory> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(merchantCategoryService.getByIdRel(id));
    }

    @ApiOperation("添加商家分类")
    @PostMapping()
    public ApiResult<?> save(@RequestBody MerchantCategory merchantCategory) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
         merchantCategory.setUserId(loginUser.getUserId());
        }
        if (merchantCategoryService.save(merchantCategory)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改商家分类")
    @PutMapping()
    public ApiResult<?> update(@RequestBody MerchantCategory merchantCategory) {
        if (merchantCategoryService.updateById(merchantCategory)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除商家分类")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (merchantCategoryService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加商家分类")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<MerchantCategory> list) {
        if (merchantCategoryService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改商家分类")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<MerchantCategory> batchParam) {
        if (batchParam.update(merchantCategoryService, "category_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除商家分类")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (merchantCategoryService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
